<button value="2nd-gen" default="">2nd gen</button> <button value="connect">Developer Connect</button>

Cloud Build lets you create triggers to build from
repositories hosted on [GitLab Enterprise Edition](https://about.gitlab.com/enterprise/).
You can execute builds in response to events such as commit pushes or
merge requests associated with your GitLab Enterprise Edition repository.

This page explains how you can enable build triggers for a
GitLab Enterprise Edition instance. For more information, see
[Cloud Build triggers](https://docs.cloud.google.com/build/docs/triggers) and
[Cloud Build repositories](https://docs.cloud.google.com/build/docs/repositories).

## Before you begin

Follow the instructions to [connect to a GitLab Enterprise Edition host](https://docs.cloud.google.com/build/docs/automating-builds/github/connect-host-github-enterprise).

-


  Enable the Cloud Build and Secret Manager APIs, if any are not already enabled.


  **Roles required to enable APIs**


  To enable APIs, you need the `serviceusage.services.enable` permission. If you
  created the project, then you likely already have this permission through the
  Owner role (`roles/owner`). Otherwise, you can get this permission through the
  Service Usage Admin role (`roles/serviceusage.serviceUsageAdmin`).
  [Learn how to grant roles](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access).

  [Enable the APIs](https://console.cloud.google.com/apis/enableflow?apiid=cloudbuild.googleapis.com,secretmanager.googleapis.com&redirect=https://cloud.google.com/build/docs/automating-builds/gitlab/build-repos-from-gitlab-enterprise-edition)

To create a trigger for a GitLab Enterprise Edition repository, you must have a connection
between Google Cloud and your repository. To create a connection through the
GitLab Enterprise Edition app in Google Cloud, see
[Connect to a GitLab Enterprise Edition repository](https://docs.cloud.google.com/build/docs/automating-builds/gitlab/connect-repo-gitlab-enterprise-edition).

## Create a GitLab Enterprise Edition trigger

This section explains how you can create a trigger and link it to your
GitLab Enterprise installation.

### Google Cloud console

To create GitLab Enterprise Edition triggers using the Google Cloud console, do the following:

1. Open the **Triggers** page:

   <br />

   [Open the Triggers page](https://console.cloud.google.com/cloud-build/triggers)

   <br />

2. Select your Google Cloud project from the top of the page and click **Open**.

3. Click **Create trigger**.

4. Enter the following trigger settings:

   - **Name**: A name for your trigger.

   - **Region** : Select the [region](https://docs.cloud.google.com/build/docs/locations) for your trigger.


     - If the build config file associated with the trigger specifies a [private pool](https://docs.cloud.google.com/build/docs/private-pools/private-pools-overview), then Cloud Build uses the private pool to run your build. In this case, the region you specify in your trigger must match the region where you created your private pool.
     - If the build config file associated with the trigger **doesn't** specify a private pool, then Cloud Build uses the default pool to run your build in the same region as your trigger.

     <br />

   - **Description** (Optional): A description for your trigger.

   - **Event**: Select the repository event to invoke your trigger.

     - **Push to a branch**: Set your trigger to start a build on commits to
       a particular branch.

     - **Push new tag**: Set your trigger to start a build on commits that
       contain a particular tag.

     - **Pull request**: Set your trigger to start a build
       on commits to a merge request.

   - **Source**: Configure information about your GitLab Enterprise Edition repository:

     - **Repository service**: Select Cloud Build.

     - **Repository generation** : Select **2nd generation** as your source.

     > [!NOTE]
     > **Note:** The region of your repository must match the region of your trigger.

     - **Repository**: From the list of available repositories, select the
       repository.

     - **Branch** or **Tag** : Specify a regular expression with the branch or
       tag value to match. For information on acceptable regular expression syntax,
       see [RE2 syntax](https://github.com/google/re2/wiki/Syntax).

     - **Comment control** : If you selected **Pull request**
       as your **Event**, choose one of the following options to
       control whether a build is automatically executed by the trigger:

       - **Required except for owners and collaborators** : When a pull
         request is created or updated by a repository owner or collaborator,
         builds are automatically executed by the trigger. If an external
         contributor initiates the action, builds are executed only after
         an owner or collaborator comments `/gcbrun` on the pull request.

       - **Required** : When a pull request is created or updated by any
         contributor, builds are executed only after an owner or
         collaborator comments `/gcbrun` on the pull request. Builds
         are executed each time a change to a pull request is made.

       - **Not required**: When a pull request is created or updated by any
         contributor, builds are automatically be executed by triggers.

     > [!WARNING]
     > **Warning:** Any user with read access to the repository can submit a pull request, which may execute a build that includes changes to the source code in the pull request. To disable this behavior, we recommend using [manual approvals](https://docs.cloud.google.com/build/docs/automating-builds/approve-builds) to gate builds when making pull requests on public repositories. You can also learn more about the [build-time privileges of triggers](https://docs.cloud.google.com/build/docs/cloud-build-service-account#build_triggers).

   - **Configuration**: Select the build config file located in
     your repository or configure your build inline on
     the trigger.

     - **Type**: Select the type of configuration to use for your build.

       - **Cloud Build configuration file (yaml or json)**: Use a build config file for your configuration.
       - **Dockerfile** : Use a `Dockerfile` for your configuration.
     - **Location**: Specify the location for your configuration.

       - **Repository** : If your config file is located in your
         repository, provide the location of your
         [build config file](https://docs.cloud.google.com/build/docs/build-config) or the `Dockerfile`
         directory and a name for the resulting image. If your configuration
         is a `Dockerfile`, you can optionally provide a timeout for your build.
         When you've provided the `Dockerfile` and image name, you'll see a
         preview of the `docker build` command that your build will execute.

       - **Inline** : If you selected
         **Cloud Build configuration file (yaml or json)** as
         your configuration option, you can specify your build config
         inline. Click **Open Editor** to write your build config file in the
         Google Cloud console using YAML or JSON syntax. Click **Done** to
         save your build config.

       > [!NOTE]
       > **Note:** Inline build configuration support is not available for `Dockerfile`.

5. Click **Create** to create your GitLab Enterprise Edition trigger.

### gcloud CLI

To create GitLab Enterprise Edition triggers using `gcloud` commands, run the following
command:

        gcloud builds triggers create gitlab \
          --name=TRIGGER_NAME \
          --repository=projects/PROJECT_ID/locations/REGION/connections/CONNECTION_NAME/repositories/REPO_NAME \
          --branch-pattern=BRANCH_PATTERN # or --tag-pattern=TAG_PATTERN \
          --build-config=BUILD_CONFIG_FILE \
          --region=REGION \
          --service-account=SERVICE-ACCOUNT

Where:

- <var translate="no">TRIGGER_NAME</var> is the name of your trigger.
- <var translate="no">PROJECT_ID</var> is your Google Cloud project ID.
- <var translate="no">REGION</var> is the [region](https://docs.cloud.google.com/build/docs/locations) of your trigger.
- <var translate="no">CONNECTION_NAME</var> is the name of your GitLab Enterprise Edition connection.
- <var translate="no">REPO_NAME</var> is the name of your repository
- <var translate="no">BRANCH_PATTERN</var> is the branch name in your repository to invoke the build on.
- <var translate="no">TAG_PATTERN</var> is the tag name in your repository to invoke the build on.
- <var translate="no">BUILD_CONFIG_FILE</var> is the path to your build configuration file.
- <var translate="no">SERVICE-ACCOUNT</var> is the service account to use for trigger and build operations.

### API

To create a GitLab Enterprise Edition trigger with the API, use the
following JSON template:

    {
        "filename": "cloudbuild.yaml",
        "name": "curl-trigger",
        "description": "curl trigger",
        "repository_event_config": {
          "repository": "REPO_NAME",
          "repository_type": "GITLAB_ENTERPRISE",
          // Field filter must be only one of the following:
          "pullRequest": "PULL_REQUEST_FILTER",
          "push": "PUSH_FILTER"
        }
    }

Where:

- "<var translate="no">REPO_NAME</var>" is the name of the repository connection that you configured in Cloud Build.
- "<var translate="no">PULL_REQUEST_FILTER</var>" is an instance of [`PullRequestFilter`](https://docs.cloud.google.com/build/docs/api/reference/rest/v1/projects.locations.triggers#BuildTrigger.PullRequestFilter), which defines the filter that allows Cloud Build to trigger a build when a matching pull request is made in GitLab Enterprise Edition.
- "<var translate="no">PUSH_FILTER</var>" is an instance of [`PushFilter`](https://docs.cloud.google.com/build/docs/api/reference/rest/v1/projects.locations.triggers#BuildTrigger.PushFilter), which defines the filter that allows Cloud Build to trigger a build when a matching push is made in GitLab Enterprise Edition.

Enter the following `curl` command in your terminal:

      curl -X POST -H "Authorization: Bearer "$(gcloud auth print-access-token) -H "Content-Type: application/json; charset=utf-8" -H "x-goog-user-project: PROJECT_NUMBER" https://cloudbuild.googleapis.com/v1/projects/PROJECT_ID/triggers -d @trigger.json

Where:

- <var translate="no">PROJECT_NUMBER</var> is your Google Cloud project number.
- <var translate="no">PROJECT_ID</var> is your Google Cloud project ID.

## Data sharing

The data sent to GitLab Enterprise Edition from Cloud Build helps you identify triggers by name and see build results on your GitLab Enterprise Edition repositories.

The following data is shared between Cloud Build and your GitLab Enterprise Edition host:

- Google Cloud project ID
- Trigger name

## What's next

- Learn how to [manage build triggers](https://docs.cloud.google.com/build/docs/automating-builds/create-manage-triggers).
- Learn how to [build repositories from GitLab Enterprise Edition in a private network](https://docs.cloud.google.com/build/docs/automating-builds/gitlab/build-repos-from-gitlab-enterprise-edition-private-network).
- Learn how to [perform blue-green deployments on Compute Engine](https://docs.cloud.google.com/build/docs/deploying-builds/deploy-compute-engine).